
#include <stdio.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/time.h>
#include <fcntl.h>

#include <pthread.h>

void handler()
{
    printf("ping %d\n", getpid());
}

int bar(int a)
{
     return foo(!a);
}

int foo(int a)
{
    switch(a)
	{
	case 0:
	    return 12345;
	case 1:
	    return bar(a);
	default:
	    return 0;
	}
}

void blah()
{
    foo(2);
}

void set_timer()
{
    struct itimerval it;
    struct sigaction sa;

    memset(&sa, 0, sizeof(sa));
    sa.sa_handler = handler;
    sa.sa_flags   = SA_RESTART;
    sigaction(SIGALRM, &sa, NULL);

    memset(&it, 0, sizeof(it));
    it.it_value.tv_usec    = 100000;
    it.it_interval.tv_usec = 100000;
    setitimer(ITIMER_REAL, &it, NULL);


}

int get_random(int q)
{
    return random() % q;
}


void *runner(void *unused)
{
    int i;

    set_timer();

    for(i = 0; i < 1000000; i++)
        foo(get_random(2));
}


void test1()
{
  int fd = open("/dev/null", O_RDONLY);
  close(fd);
}

int main()
{
#if 1
    pthread_t t1, t2;

    pthread_create(&t1, NULL, runner, NULL);
    pthread_create(&t2, NULL, runner, NULL);

    pthread_join(t1, 0);
    pthread_join(t2, 0);
#else
    //runner(0);
    test1();
#endif
	printf("proftest %d exiting\n", getpid());
    exit(101);
}
